var setting_data = setting_data;
var booking_package_dictionary = booking_package_dictionary;

window.onload = function(){
    
    if(setting_data != null && booking_package_dictionary != null){
    	
    	var setting = new SETTING(setting_data, booking_package_dictionary, false);
    	setting.loadTabFrame();
    	
    }
    
}

window.onerror = function(msg, url, line, col, error){
    
    var error = new scriptError(setting_data, booking_package_dictionary, msg, url, line, col, error);
    error.send();
    
}

function SETTING(setting_data, booking_package_dictionary, webApp) {
	
	/**
	constructor(setting_data, booking_package_dictionary, webApp){
		
		console.log(setting_data);
		this._webApp = webApp;
		this._setting_data = setting_data;
		this._url = setting_data['url'];
		this._nonce = setting_data['nonce'];
		this._action = setting_data['action'];
		this._settingList = setting_data['list'];
		this._bookingSyncList = setting_data['bookingSyncList'];
		
		this._i18n = new I18n(setting_data.locale);
    	this._i18n.setDictionary(booking_package_dictionary);
    	
    	this._blockPanel = document.getElementById("blockPanel");
    	this._editPanel = document.getElementById("editPanel");
    	this._loadingPanel = document.getElementById("loadingPanel");
    	
    	this.loadTabFrame();
    
    	this._blockPanel.onclick = function(){
        	
        	this.editPanelShow(false);
        	
    	}
    	
    	document.getElementById("media_modal_close").onclick = function(){
        	
        	this.editPanelShow(false);
        
    	}
		
	}
	**/
	
	console.log(setting_data);
	this._webApp = webApp;
	this._setting_data = setting_data;
	this._url = setting_data['url'];
	this._nonce = setting_data['nonce'];
	this._action = setting_data['action'];
	this._settingList = setting_data['list'];
	this._bookingSyncList = setting_data['bookingSyncList'];
	this._isExtensionsValid = parseInt(setting_data.isExtensionsValid);
	
	this._i18n = new I18n(setting_data.locale);
	this._i18n.setDictionary(booking_package_dictionary);
	
	this._blockPanel = document.getElementById("blockPanel");
	this._editPanel = document.getElementById("editPanel");
	this._loadingPanel = document.getElementById("loadingPanel");
	
	//this.loadTabFrame();

	this._blockPanel.onclick = function(){
    	
    	this.editPanelShow(false);
    	
	}
	
	document.getElementById("media_modal_close").onclick = function(){
    	
    	this.editPanelShow(false);
    
	}
	
	this.loadTabFrame = function(){
		
		var object = this;
		object.createSettingPanel();
		
		var menuList = {settingLink: 'settingPanel', /**formLink: 'formPanel', courseLink: 'coursePanel', emailLink: 'emailPanel',**/ syncLink: "syncPanel", subscriptionLink: 'subscriptionPanel'};
		for(var key in menuList){
			
			var button = document.getElementById(key);
			button.setAttribute("data-key", key);
			button.onclick = function(event){
				
				var clickKey = this.getAttribute("data-key");
				console.log(clickKey);
				for(var key in menuList){
					
					var link = document.getElementById(key);
					var panel = document.getElementById(menuList[key]);
					if(clickKey == key){
						
						link.setAttribute("class", "menuItem active");
						panel.setAttribute("class", "");
						
						if(clickKey == 'formLink'){
							
							object.createFormPanel();
							
						}else if(clickKey == 'courseLink'){
							
							object.createCoursePanel();
							
						}else if(clickKey == 'emailLink'){
							
							object.emailSettingPanel();
							
						}else if(clickKey == 'subscriptionLink'){
							
							object.subscriptionDiteilPanel();
							
						}else if(clickKey == 'syncLink'){
							
							object.syncPanel();
							
						}
						
					}else{
						
						link.setAttribute("class", "menuItem");
						panel.setAttribute("class", "hidden_panel");
						
					}
					
				}
				
			}
			
		}
		
	}
	
	this.subscriptionDiteilPanel = function(){
		
		var object = this;
		//var upgrade = new Upgrade();
		
		var showBool = true;
		if(
			parseInt(object._setting_data.customer_id_for_subscriptions) == 0 &&
			parseInt(object._setting_data.id_for_subscriptions) == 0 &&
			parseInt(object._setting_data.invoice_id_for_subscriptions) == 0
		){
			
			showBool = false;
			
		}
		
		var subscriptionData = {
			customer_id_for_subscriptions: object._setting_data.customer_id_for_subscriptions,
			id_for_subscriptions: object._setting_data.id_for_subscriptions,
			invoice_id_for_subscriptions: object._setting_data.invoice_id_for_subscriptions,
			expiration_date_for_subscriptions: object._setting_data.expiration_date_for_subscriptions,
			expiration_date: object._setting_data.expiration_date,
			customer_email_for_subscriptions: object._setting_data.customer_email_for_subscriptions
		};
		
		var nameList = {
			customer_id_for_subscriptions: object._i18n.get("ID"),
			id_for_subscriptions: object._i18n.get("Subscriptions ID"),
			invoice_id_for_subscriptions: object._i18n.get("Invoice ID"),
			expiration_date: object._i18n.get("Expiration date"),
			customer_email_for_subscriptions: object._i18n.get("Customers email")
		};
		console.log(subscriptionData);
		
		var subscriptionPanel = document.getElementById("subscriptionPanel");
		subscriptionPanel.textContent = null;
		
		var table = document.createElement("table");
		table.setAttribute("class", "emails_table table_option wp-list-table widefat fixed striped")
		subscriptionPanel.appendChild(table);
		
		for(var key in nameList){
			
			var nameTh = document.createElement("th");
			nameTh.textContent = nameList[key];
			
			var valueTd = document.createElement("td");
			valueTd.textContent = subscriptionData[key];
			if(showBool == false){
				
				valueTd.textContent = "";
				
			}
			
			var tr = document.createElement("tr");
			tr.appendChild(nameTh);
			tr.appendChild(valueTd);
			table.appendChild(tr);
			
		}
		
		var cancelSubscription = document.createElement("div");
		cancelSubscription.classList.add("cancelSubscription");
		cancelSubscription.textContent = this._i18n.get("Cancel subscription");
		if(showBool == true){
			
			subscriptionPanel.appendChild(cancelSubscription);
			
		}
		cancelSubscription.onclick = function(event){
			
			console.log(subscriptionData);
			
			var confirm = new Confirm();
			confirm.dialogPanelShow(object._i18n.get("Confirm to cancel"), object._i18n.get("Do you really cancel the subscription?"), false, function(response){
				
				console.log(response);
				if(response === true){
					
					object._loadingPanel.setAttribute("class", "loading_modal_backdrop");
					var extension_url = object._setting_data.extension_url + "cancelSubscription/";
					console.log("extension_url = " + extension_url);
					var postData = {customer_id: subscriptionData.customer_id_for_subscriptions, subscriptions_id: subscriptionData.id_for_subscriptions};
					var xmlHttp = new Booking_App_XMLHttp(extension_url, postData, object._webApp, function(json){
						
						console.log(json);
						if(json["status"] == "success"){
							
							var postData = {mode: "upgradePlan", type: "delete", nonce: object._nonce, action: object._action};
    						var xmlHttp = new Booking_App_XMLHttp(object._url, postData, object._webApp, function(json){
								
								if(json['status'] != 'error'){
									
									object.subscriptionDiteilPanel();
									
								}
								object._loadingPanel.setAttribute("class", "hidden_panel");
								
							});
							
						}
						
					});
					
				}
				
			});
			
		}
	
	}
	
	this.sortData = function(key, className, list, panel, mode){
		
		console.log(list);
		var sortBool = false;
		var panelList = panel.getElementsByClassName(className);
		for(var i = 0; i < list.length; i++){
			
			var index = parseInt(panelList[i].getAttribute("data-key"));
			if(i != index){
				
				sortBool = true;
				break;
				
			}
			
		}
		
		var keyList = [];
		var indexList = [];
		if(sortBool === true){
			
			for(var i = 0; i < panelList.length; i++){
				
				keyList.push(list[i][key]);
				var index = parseInt(panelList[i].getAttribute("data-key"));
				indexList.push(index);
				console.log(panelList[i]);
				
			}
			
		}
		
		console.log(keyList);
		console.log(indexList);
		return sortBool;
		
	}
	
	this.changeRank = function(key, className, list, panel, mode, callback){
		
		var object = this;
		object._loadingPanel.setAttribute("class", "loading_modal_backdrop");
		var newList = [];
		var keyList = [];
		var indexList = [];
		
		var panelList = panel.getElementsByClassName(className);
		for(var i = 0; i < panelList.length; i++){
			
			
			var panelKey = parseInt(panelList[i].getAttribute("data-key"));
			newList.push(list[panelKey]);
			keyList.push(list[panelKey][key]);
			
			indexList.push(i);
			console.log(panelList[i]);
			
		}
		
		var postData = {mode: mode, nonce: object._nonce, action: object._action, keyList: keyList.join(","), indexList: indexList.join(",")};
		var xmlHttp = new Booking_App_XMLHttp(object._url, postData, object._webApp, function(json){
			
			callback(json);
			object._loadingPanel.setAttribute("class", "hidden_panel");
			
		});
		
		return newList;
		
	}
	
	this.addNewCourse1 = function(callback){
		
		var object = this;
		var media_frame_content = document.getElementById("media_frame_content")
		media_frame_content.textContent = null;
    	var edit_title = document.getElementById("edit_title");
    	edit_title.textContent = this._i18n.get("New service");
    	
    	document.getElementById("menu_panel").setAttribute("class", "media_frame_menu hidden_panel");
    	document.getElementById("media_title").setAttribute("class", "media_left_zero");
    	document.getElementById("media_router").setAttribute("class", "media_left_zero");
    	document.getElementById("media_frame_content").setAttribute("class", "media_left_zero");
    	document.getElementById("frame_toolbar").setAttribute("class", "media_frame_toolbar media_left_zero");
    	
    	var inputData = {};
    	var courseDataList = object._setting_data['courseData'];
    	var courseTimeList = {};
    	var index = 0;
    	for(var i = 5; i < 1440; i += 5){
    		
    		courseTimeList[i] = i + "min";
    		
    	}
    	
    	courseDataList['time']['valueList'] = courseTimeList;
		console.log(courseDataList);
		
		var table = document.createElement("table");
		table.setAttribute("class", "form-table");
		
		for(var key in courseDataList){
			
			console.log(key);
        	var courseData = courseDataList[key];
        	
        	var th = document.createElement("th");
        	th.setAttribute("scope", "row");
        	th.textContent = key;
        	
        	var inputPanel = object.createInput(key, courseData, inputData, false, false);
        	var td = document.createElement("td");
        	td.appendChild(inputPanel);
        	
        	var tr = document.createElement("tr");
        	tr.setAttribute("valign", "top");
        	tr.appendChild(th);
        	tr.appendChild(td);
        	table.appendChild(tr);
			
		}
    	
    	media_frame_content.appendChild(table);
    	object.editPanelShow(true);
		
	}
	
	this.isJSON = function(arg) {
		
		arg = (typeof arg === "function") ? arg() : arg;
		if (typeof arg  !== "string") {
			return false;
		}
    	
		try {
			arg = (!JSON) ? eval("(" + arg + ")") : JSON.parse(arg);
			return true;
		} catch (e) {
			return false;
		}
	
	}
	
	this.syncPanel = function(){
		
		var object = this;
		var google_calendar_api_panel = function(messagePanel, parse_url, bookingSyncList){
    		
    		console.log(bookingSyncList.booking_package_googleCalendar_json);
    		console.log(parse_url);
    		var sync_url = parse_url.scheme + "://" + parse_url.host + "/?webhook=google";
    		//document.getElementById("webhook_url_for_google").value = sync_url;
    		console.log("sync_url = " + sync_url);
    		if(parse_url.scheme != 'https'){
    			
    			
    			
    		}
    		
    		var client_email = "no value";
    		var booking_package_googleCalendar_json = bookingSyncList.booking_package_googleCalendar_json.value;
    		if(booking_package_googleCalendar_json != null && booking_package_googleCalendar_json.length != 0){
    			
    			if(object.isJSON(booking_package_googleCalendar_json)){
    				
    				var json = JSON.parse(booking_package_googleCalendar_json);
    				client_email = json.client_email;
    				console.log(client_email);
    				
    			}
    			
    		}
    		
    		var googleCalendarLink = document.getElementById("googleCalendarLink");
    		var url = "https://saasproject.net/googleCalendar/?sync_url=" + encodeURIComponent(sync_url) + "&client_email=" + encodeURIComponent(client_email);
    		googleCalendarLink.href = url;
    		
    		var google_calendar_api = document.getElementById("google_calendar_api").cloneNode(true);
    		google_calendar_api.classList.remove("hidden_panel");
    		google_calendar_api.setAttribute("class", "");
    		messagePanel.appendChild(google_calendar_api);
    		
    		
    	}
		
		console.log(object._bookingSyncList);
		var bookingSync_table = document.getElementById("bookingSync_table");
		bookingSync_table.textContent = null;
    	var inputData = {};
    	var messageList = {};
    	messageList["iCal"] = this._i18n.get("By using iCal you can share calendars and reservations for Google Calendar, Apple Calendar, iCal format.");
    	messageList["Google_Calendar"] = "";
    	
    	for(var i in object._bookingSyncList){
    		
    		var disabled = false;
    		
    		if(i == 'Google_Calendar'){
    			
    			if(typeof ExtensionsFunction != "function"){
    				
    				disabled = true;
    				
    			}
    			
    		}
    		
    		
    		var title = document.createElement("div");
    		title.classList.add("title");
    		title.textContent = i;
    		bookingSync_table.appendChild(title);
    		
    		if(messageList[i] != null){
    			
    			var message = document.createElement("div");
    			message.textContent = messageList[i];
    			bookingSync_table.appendChild(message);
    			if(i == 'Google_Calendar'){
    				
    				google_calendar_api_panel(message, object._bookingSyncList[i].parse_url, object._bookingSyncList[i]);
    				
    			}
    			
    		}
    		
    		var table = document.createElement("table");
    		table.setAttribute("class", "form-table");
    		bookingSync_table.appendChild(table);
    		for(var key in object._bookingSyncList[i]){
    			
    			console.log(object._bookingSyncList[i]);
    			var list = object._bookingSyncList[i][key];
    			var th = document.createElement("th");
    			th.setAttribute("scope", "row");
    			th.textContent = list.name;
				
				var inputPanel = object.createInput(key, list, inputData, disabled, false);
				if(list.inputType == "CUSTOMIZE"){
					
					console.log("CUSTOMIZE");
					var tokenDate = list;
					var tokenButton = document.createElement("Button");
					tokenButton.textContent = this._i18n.get("Refresh token");
					tokenButton.setAttribute("data-Key", key);
					tokenButton.setAttribute("class", "w3tc-button-save button-primary tokenButton");
					
					var tokenValue = document.createElement("div");
					tokenValue.textContent = tokenDate.home + "?ical=" + tokenDate.value;
					tokenValue.setAttribute("class", "tokenValue");
					inputPanel.appendChild(tokenValue);
					inputPanel.appendChild(tokenButton);
					
					tokenButton.onclick = function(){
						
						var key = this.getAttribute("data-key");
						object.refreshToken(key, function(new_token){
							
							console.log(new_token);
							tokenValue.textContent = tokenDate.home + "?ical=" + new_token.token;
							
						});
						
					}
					
				}
				
				var td = document.createElement("td");
				td.appendChild(inputPanel);
				
				if(list['type'] == 'radio' || list['type'] == 'check' || list['type'] == 'select'){
					
					console.log(list['type']);
					if(typeof list['valueList'] == 'object'){
						
						console.log(list['valueList']);
						
					}
				
				}
				
				var tr = document.createElement("tr");
				tr.setAttribute("valign", "top");
				tr.appendChild(th);
				tr.appendChild(td);
				table.appendChild(tr);
    			
    		}
    		
    		
			
		}
		
		console.log(inputData);
    	if(inputData.booking_app_googleCalendar_json){
    		
    		console.log(inputData.booking_app_googleCalendar_json.textBox);
    		var errorMessage = 'To display "Client ID" here, enter JSON in "Service account".';
    		var client_id_for_google = document.getElementById("client_id_for_google");
    		var value = inputData.booking_app_googleCalendar_json.textBox.value;
    		if(value.length != 0){
    			
    			var value = JSON.parse(value);
    			var client_email = value.client_email;
    			client_id_for_google.value = client_email;
    			console.log(client_id_for_google);
    			
    		}else{
    			
    			client_id_for_google.value = errorMessage;
    			
    		}
    		
    		inputData.booking_app_googleCalendar_json.textBox.onchange = function(){
    			
    			var value = inputData.booking_app_googleCalendar_json.textBox.value;
    			var value = JSON.parse(value);
    			if(value.client_email){
    				
    				var client_email = value.client_email;
    				client_id_for_google.value = client_email;
    				console.log(client_email);
    				console.log(client_id_for_google);
    				
    			}else{
    				
    				client_id_for_google.value = errorMessage;
    				
    			}
    			
   			}
   			
   		}
   		
		document.getElementById("save_bookingSync").onclick = function(){
        	
        	var postData = {mode: 'setting', type: 'bookingSync', nonce: object._nonce, action: object._action};
        	var input = new Input();
        	console.log(inputData);
        	var valueList = {};
        	
        	for(var i in object._bookingSyncList){
        		
        		for(var key in object._bookingSyncList[i]){
					
					if(inputData[key] != null){
						
						console.log(key);
						console.log(object._bookingSyncList[i][key]);
						console.log(inputData[key]);
						var bool = input.inputCheck(key, object._bookingSyncList[i][key], inputData[key], valueList);
						var value = valueList[key].join(',');
						if(value.length == 0 && Object.keys(inputData[key]).length == 1 && object._bookingSyncList[i][key].inputType == "CHECK"){
							value = 0;
						}
						
						postData[key] = value;
						
					}
        		
				}
				
        	}
        	console.log(valueList);
        	console.log(postData);
        	
        	if(postData.booking_package_googleCalendar_json.length != 0 && object.isJSON(postData.booking_package_googleCalendar_json) == false){
        		
        		//alert("The Service account must be in JSON format.");
        		var confirm = new Confirm();
        		confirm.alertPanelShow(this._i18n.get("Error"), this._i18n.get("The Service account must be in JSON format."), false, function(){});
        		
        		return null;
        		
        	}
        	
        	var loadingPanel = document.getElementById("loadingPanel");
        	loadingPanel.classList.remove("hidden_panel");
        	var xmlHttp = new Booking_App_XMLHttp(object._url, postData, object._webApp, function(json){
				
				console.log(json);
				loadingPanel.classList.add("hidden_panel");
									
			});
        	
    	}
		
	}
	
	this.createSettingPanel = function(){
		
		var object = this;
		object._loadingPanel.classList.add("hidden_panel");
		console.log(object._settingList);
		var setting_table = document.getElementById("setting_table");
    	var inputData = {};
    	var messageList = {};
    	messageList["Mailgun"] = this._i18n.get("Mailgun is an email automation service. It offers a complete cloud-based email service for sending, receiving and tracking email sent through your websites and applications.");
    	messageList["Stripe"] = this._i18n.get('Stripe is the best way to accept payments online and in mobile apps.');
    	
    	for(var i in object._settingList){
    		
    		var disabled = false;
    		if(i == 'Mailgun' || i == 'Stripe' || i == 'PayPal'){
    			
    			if(typeof ExtensionsFunction != "function"){
    				
    				disabled = true;
    				
    			}
    			
    		}
    		
    		var title = document.createElement("div");
    		title.classList.add("title");
    		title.textContent = i;
    		setting_table.appendChild(title);
    		
    		if(messageList[i] != null){
    			
    			var message = document.createElement("div");
    			message.textContent = messageList[i];
    			setting_table.appendChild(message);
    			
    		}
    		
    		var table = document.createElement("table");
    		table.setAttribute("class", "form-table");
    		setting_table.appendChild(table);
    		for(var key in object._settingList[i]){
    			
    			var list = object._settingList[i][key];
    			var th = document.createElement("th");
    			th.setAttribute("scope", "row");
    			th.textContent = list.name;
				
				var idBool = false;
				if(i == 'Design'){
					idBool = true;
				}
				
				var inputPanel = object.createInput(key, list, inputData, disabled, idBool);
				var td = document.createElement("td");
				td.appendChild(inputPanel);
				
				if(list['type'] == 'radio' || list['type'] == 'check' || list['type'] == 'select'){
					
					console.log(list['type']);
					console.log(list.valueList);
					if(typeof list['valueList'] == 'object'){
						
						console.log(list['valueList']);
						
					}
				
				}
				
				var tr = document.createElement("tr");
				tr.setAttribute("valign", "top");
				tr.appendChild(th);
				tr.appendChild(td);
				table.appendChild(tr);
				
				if(i == 'Design' && list.js != null){
					
					(function( $ ) {
						
						$(function() {
							console.log("key = " + key);
							console.log($('#' + key));
							$('#' + key).wpColorPicker();
							
						});
						
					})( jQuery );
					
				}
    			
    		}
			
		}
    	
    	document.getElementById("save_setting").onclick = function(){
        	
        	var loadingPanel = document.getElementById("loadingPanel");
        	loadingPanel.classList.remove("hidden_panel");
        	
        	var postData = {mode: 'setting', nonce: object._nonce, action: object._action};
        	var input = new Input();
        	console.log(inputData);
        	var valueList = {};
        	
        	for(var i in object._settingList){
        		
        		if(i == 'Mailgun' || i == 'Stripe'){
    				
    				if(typeof ExtensionsFunction != "function"){
    					
    					continue;
    					
    				}
    				
        		}
        		
        		for(var key in object._settingList[i]){
					
					if(inputData[key] != null){
						
						console.log(key);
						console.log(object._settingList[i][key]);
						console.log(inputData[key]);
						var bool = input.inputCheck(key, object._settingList[i][key], inputData[key], valueList);
						var value = valueList[key].join(',');
						if(value.length == 0 && Object.keys(inputData[key]).length == 1 && object._settingList[i][key].inputType == "CHECK"){
							value = 0;
						}
						
						postData[key] = value;
						
					}
        			
				}
				
        	}
        	
        	console.log(valueList);
        	console.log(postData);
        	var xmlHttp = new Booking_App_XMLHttp(object._url, postData, object._webApp, function(json){
				
				console.log(json);	
				loadingPanel.classList.add("hidden_panel");
									
			});
        	
    	}
		
	}
	
	this.getInputData = function(inputTypeList, inputData){
		
		var postData = {};
		for(var key in inputTypeList){
    		
    		console.log(key);
    		var values = [];
    		var inputType = inputTypeList[key];
    		console.log(inputType);
    		for(var inputKey in inputData[key]){
    			
    			var bool = true;
    			if(inputType['inputType'] == 'TEXT' || inputType['inputType'] == 'TEXTAREA'){
    				
    				if(inputData[key][inputKey].value.length == 0 && inputType.inputLimit == '1'){
    					
    					bool = false;
    					
    				}else{
    					
    					values.push(inputData[key][inputKey].value);
    					
    				}
    				
    			}else if(inputType['inputType'] == 'CHECK' || inputType['inputType'] == 'RADIO'){
    				
    				if(inputData[key][inputKey].checked == true){
    					
    					values.push(inputData[key][inputKey].getAttribute("data-value"));
    					
    				}
    				
    			}else if(inputType['inputType'] == 'OPTION'){
    				
    				if(inputData[key][inputKey].checked == true){
    					
    					values.push(inputData[key][inputKey].value);
    					
    				}
    				
    			}else if(inputType['inputType'] == 'SELECT'){
    				
    				var index = inputData[key][inputKey].selectedIndex;
    				values.push(inputData[key][inputKey].options[index].value);
    				
    			}
    			
    		}
    		
    		if(bool === true){
    			
    			postData[key] = values.join(",");
    			
    		}else{
    			
    			postData[key] = false;
    			
    		}
    		
    		//postData[key] = false;
    		console.log(inputData[key]);
    		
    	}
		
		return postData;
		
	}
	
	this.createInput = function(inputName, input, inputData, disabled, idBool){
		
		console.log("createInput");
		console.log(input);
		var object = this;
		var isExtensionsValid = 0;
		if(input.isExtensionsValid != null){
			
			isExtensionsValid = parseInt(input.isExtensionsValid);
			
		}
		var list = null;
		if(input['valueList'] != null){
	    	
	    	list = input['valueList'];
	    	
		}
		
		console.log(list);
		var valuePanel = document.createElement("div");
		valuePanel.classList.add("valuePanel");
		if(isExtensionsValid == 1 && object._isExtensionsValid == 0){
			
			console.log("isExtensionsValid = " + isExtensionsValid);
			var extensionsValidPanel = document.createElement("div");
            extensionsValidPanel.classList.add("extensionsValid");
            extensionsValidPanel.textContent = object._i18n.get("Subscription version");
            valuePanel.appendChild(extensionsValidPanel);
			
		}
		
		
		if(input['inputType'] == 'TEXT'){
			
			var textBox = document.createElement("input");
			textBox.setAttribute("class", "regular-text");
			textBox.type = "text";
			textBox.value = input['value'];
			textBox.disabled = disabled;
			if(idBool == true){
				
				textBox.id = inputName;
				
			}
			
			valuePanel.appendChild(textBox);
			inputData[inputName] = {textBox: textBox};
			
		}else if(input['inputType'] == 'SELECT'){
			
			var selectBox = document.createElement("select");
			selectBox.disabled = disabled;
			console.log(typeof list);
			console.log(list);
			for(var key in list){
				
				var optionBox = document.createElement("option");
				optionBox.value = key;
				optionBox.textContent = list[key];
				
				console.log("key = " + key + " content = " + list[key]);
				if(key == input['value']){
					
					console.log("value = " + input['value']);
					optionBox.selected = true;
					
				}
				
				selectBox.appendChild(optionBox);
				
			}
			
			valuePanel.appendChild(selectBox);
			inputData[inputName] = {selectBox: selectBox};
			
		}else if(input['inputType'] == 'SELECT_GROUP'){
			
			var selectBox = document.createElement("select");
			selectBox.disabled = disabled;
			console.log(typeof list);
			console.log(list);
			
			var selectedvalue = null;
			for(var key in list){
				
				if(list[key]['alpha-2'] == input['value']){
					
					selectedvalue = key;
					break;
					
				}
				
			}
			
			if(selectedvalue == null){
				
				selectedvalue = "United States of America";
				
			}
			
			var selectedCountry = list[selectedvalue];
			console.log(selectedCountry)
			
			var optionBox = document.createElement("option");
			optionBox.value = selectedCountry['alpha-2'];
			optionBox.textContent = selectedCountry.name;
			
			var optgroup = document.createElement("optgroup");
			optgroup.setAttribute("label", this._i18n.get("Selected country"));
			optgroup.appendChild(optionBox);
			selectBox.appendChild(optgroup);
			
			var frequently = ["Canada", "France", "Germany", "Italy", "Japan", "United Kingdom of Great Britain and Northern Ireland", "United States of America"];
			var optgroup = document.createElement("optgroup");
			optgroup.setAttribute("label", this._i18n.get("Frequently used countries"));
			selectBox.appendChild(optgroup);
			
			console.log("selectedvalue = " + selectedvalue);
			for(var i = 0; i < frequently.length; i++){
				
				var key = frequently[i];
				if(list[key].name != selectedvalue){
					
					var optionBox = document.createElement("option");
					optionBox.value = list[key]['alpha-2'];
					optionBox.textContent = list[key].name;
					optgroup.appendChild(optionBox);
					
				}
				
			}
			
			var optgroup = document.createElement("optgroup");
			optgroup.setAttribute("label", this._i18n.get("Other countries"));
			selectBox.appendChild(optgroup);
			
			for(var key in list){
				
				var optionBox = document.createElement("option");
				optionBox.value = list[key]['alpha-2'];
				optionBox.textContent = list[key].name;
				//console.log("key = " + key + " content = " + list[key]);
				if(key == input['value']){
					
					console.log("value = " + input['value']);
					optionBox.selected = true;
					
				}
				
				optgroup.appendChild(optionBox);
				
			}
			
			valuePanel.appendChild(selectBox);
			inputData[inputName] = {selectBox: selectBox};
			
		}else if(input['inputType'] == 'OPTION'){
			
			console.log("inputType = " + input['inputType']);
			console.log(input);
			var options = [];
			if(input['value'] != null){
				
				options = input['value'].split(",");
				
			}
			
			console.log(options);
			var addButton = document.createElement("label");
			//addButton.setAttribute("class", "w3tc-button-save button-primary");
			addButton.setAttribute("class", "addLink");
			addButton.textContent = this._i18n.get("Add");
			valuePanel.appendChild(addButton);
			
			var table = document.createElement("table");
			table.setAttribute("class", "table_option wp-list-table widefat fixed striped");
			valuePanel.appendChild(table);
			
			inputData[inputName] = {};
			var tr_index = 0;
			var table_tr = {};
			
			for(var i = 0; i < options.length; i++){
				
				create_tr(tr_index, table, options[i]);
				tr_index++;
				
			}
			
			addButton.onclick = function(){
				
				create_tr(tr_index, table, null);
				tr_index++;
				
			}
			
		}else if(input['inputType'] == 'CHECK'){
			
			inputData[inputName] = {};
			for(var key in list){
				
				console.log("key = " + key + " value = " + list[key])
				var valueName = document.createElement("span");
				valueName.setAttribute("class", "radio_title");
				valueName.textContent = list[key];
				
				var checkBox = document.createElement("input");
				checkBox.disabled = disabled;
				checkBox.setAttribute("data-value", key);
				checkBox.name = inputName;
				checkBox.type = "checkbox";
				checkBox.value = list[key];
				if(input['value'] == key){
					
					checkBox.checked = "checked";
					
				}
				
				var label = document.createElement("label");
				label.appendChild(checkBox);
				label.appendChild(valueName);
				valuePanel.appendChild(label);
				inputData[inputName][key] = checkBox;
				
			}
			
		}else if(input['inputType'] == 'RADIO'){
				
			inputData[inputName] = {};
			for(var key in list){
				
				console.log(key + " = " + list[key]);
				var valueName = document.createElement("span");
				valueName.setAttribute("class", "radio_title");
				valueName.textContent = list[key];
				
				var radioBox = document.createElement("input");
				radioBox.disabled = disabled;
				radioBox.setAttribute("data-value", key);
				radioBox.name = inputName;
				radioBox.type = "radio";
				radioBox.value = list[key];
				if(input['value'] == key){
					
					console.log("value = " + input['value']);
					radioBox.checked = "checked";
					
				}
				
				var label = document.createElement("label");
				label.appendChild(radioBox);
				label.appendChild(valueName);
				valuePanel.appendChild(label);
				inputData[inputName][key] = radioBox;
				
			}
			
		}else if(input['inputType'] == 'TEXTAREA'){
			
			var textareaBox = document.createElement("textarea");
			textareaBox.value = input['value'];
			textareaBox.disabled = disabled;
			valuePanel.appendChild(textareaBox);
			inputData[inputName] = {textBox: textareaBox};
			
		}
		
		function create_tr(tr_index, table, value){
				
			var textBox = document.createElement("input");
			textBox.setAttribute("data-key", tr_index);
			textBox.setAttribute("class", "regular-text");
			textBox.setAttribute("style", "width: 100%");
			textBox.type = "text";
			
			var filedTd = document.createElement("td");
			filedTd.setAttribute("class", "td_option");
			filedTd.appendChild(textBox);
			
			var deleteButton = document.createElement("label");
			deleteButton.textContent = "delete";
			deleteButton.setAttribute("data-key", tr_index);
			deleteButton.setAttribute("class", "material-icons deleteLink");
			
			var deleteTd = document.createElement("td");
			deleteTd.setAttribute("class", "td_delete td_option");
			deleteTd.appendChild(deleteButton);
			
			var tr = document.createElement("tr");
			tr.setAttribute("class", "tr_option");
			tr.appendChild(filedTd);
			tr.appendChild(deleteTd);
			
			table_tr[tr_index] = tr;
			table.appendChild(tr);
			
			var checkBox = document.createElement("input");
			checkBox.setAttribute("data-value", tr_index);
			checkBox.name = tr_index;
			checkBox.type = "checkbox";
			checkBox.value = null;
			inputData[inputName][tr_index] = checkBox;
			
			if(value != null && value.length != 0){
			
				textBox.value = value;
				checkBox.value = value;
				checkBox.checked = true;
				
			}
			
			textBox.onchange = function(){
				
				var dataKey = this.getAttribute("data-key");
				var value = this.value;
				var bool = false;
				if(value.length != 0){
					bool = true;
				}else{
					value = null;
				}
				
				inputData[inputName][dataKey].value = value;
				inputData[inputName][dataKey].checked = bool;
				console.log("dataKey = " + dataKey + " value = " + value + " bool = " + bool);
				
			}
			
			deleteButton.onclick = function(){
				
				var result = false;
				var dataKey = this.getAttribute("data-key");
				var length = inputData[inputName][dataKey].value.length;
				if(length == 0){
					
					result = true;
					
				}
				
				if(result === false){
					
					//result = confirm("Do you delete option of \"" + inputData[inputName][dataKey].value + "\"?");
					result = confirm(this._i18n.get("Do you delete option of \"%s\"?", [inputData[inputName][dataKey].value]));
					
				}
				
				if(result === true){
					
					var tr = table_tr[parseInt(dataKey)];
					table.removeChild(tr);
					delete table_tr[dataKey];
					delete inputData[inputName][dataKey];
					console.log(tr);
					console.log(table_tr);
					console.log(inputData[inputName]);
					console.log("tr_index = " + tr_index);
					
				}
				
			}
			
		}
		
		return valuePanel;
		
	}
	
	this.refreshToken = function(key, callback){
		
		console.log(key);
		var object = this;
		var postData = {mode: "refreshToken", nonce: object._nonce, action: object._action, key: key};
		object._loadingPanel.setAttribute("class", "loading_modal_backdrop");
    	var xmlHttp = new Booking_App_XMLHttp(object._url, postData, object._webApp, function(json){
			
			if(json['status'] != 'error'){
				
				callback(json);
				
			}
			object._loadingPanel.setAttribute("class", "hidden_panel");
							
		});
		
	}
	
	this.editPanelShow = function(showBool){
    	
    	var object = this;
    	var body = document.getElementsByTagName("body")[0];
    	console.log(body);
    	if(showBool == true){
        	
        	body.classList.add("modal-open");
        	object.editPanel.setAttribute("class", "edit_modal");
        	object.blockPanel.setAttribute("class", "edit_modal_backdrop");
			
    	}else{
        	
        	body.classList.remove("modal-open");
        	object.editPanel.setAttribute("class", "hidden_panel");
        	object.blockPanel.setAttribute("class", "hidden_panel");
			
    	}
		
	}
	
}
