<?php
    
    if(!defined('ABSPATH')){
    	exit;
	}
	
    class CreditCard {
    
	    public $response = array();
	    
	    public $pluginName = null;
        
	    public $lang = null;
        
	    public function __construct($pluginName){
		    
		    $this->pluginName = $pluginName;
		    
	    }
        
	    public function pay($payId, $public_key, $secret, $token, $payment_live, $amont, $currency, $key, $name){
            
            $response = array('error' => "8001");
		    if($payId == 'stripe'){
                
			    $response = $this->commitStripe($payId, $secret, $token, $amont, $currency, $key, $name);
                
		    }else if($payId == 'paypal'){
		        
		        $access_token = $this->getAccessTokenPayPal($public_key, $secret, $payment_live);
		        $response = $this->getPaymentDetailsPayPal($token, $access_token, $payment_live);
		        #var_dump($response);
		        
		    }
            
            $this->response = $response;
	        return $response;
            
        }
        
        public function cancel($payId, $public_key, $secret, $payment_live, $chargeId){
            
            #var_dump($payId);
            $response = array('error' => "8002");
            if($payId == 'stripe'){
                
                $response = $this->cancelStripe($payId, $secret, $chargeId);
                
            }else if($payId == 'paypal'){
                
                $access_token = $this->getAccessTokenPayPal($public_key, $secret, $payment_live);
                $response = $this->refoundPayPal($chargeId, $access_token, $payment_live);
                
            }
            
            $this->response = $response;
	        return $response;
            
        }
        
        public function update($payId, $public_key, $secret, $chargeId, $bookingId, $payment_live){
            
            $response = array('error' => "8002");
            if($payId == 'paypal'){
                
                $access_token = $this->getAccessTokenPayPal($public_key, $secret, $payment_live);
                $response = $this->updatePaymentPayPal($chargeId, $bookingId, $access_token, $payment_live);
                
            }
            
            $this->response = $response;
	        return $response;
            
        }
        
        public function commitStripe($payId, $secret, $token, $amont, $currency, $key, $name){
            
            $message = array();
            $params = array('source' => $token, 'amount' => $amont, 'currency' => $currency, 'description' => "ID: ".$key." Name: ".$name);
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, "https://api.stripe.com/v1/charges");
			curl_setopt($ch, CURLOPT_USERPWD, $secret.":");
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
			curl_setopt($ch, CURLOPT_POST, 1);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close ($ch);
            
            $response = json_decode($response, true);
            #var_dump($response);
            
            if($httpCode < 400){
                
                if(isset($response['id']) && $response['status'] == 'succeeded'){
                    
                    $message['cardToken'] = $response['id'];
                    
                }else{
                    
                    if($httpCode == 400){
                        
                        $message['error'] = __("The request was unacceptable, often due to missing a required parameter.", $this->pluginName);
                        
                    }else if($httpCode == 401){
                        
                        $message['error'] = __("No valid API key provided.", $this->pluginName);
                        
                    }else if($httpCode == 402){
                        
                        $message['error'] = __("The parameters were valid but the request failed.", $this->pluginName);
                        
                    }else if($httpCode == 404){
                        
                        $message['error'] = __("The requested resource doesn't exist.", $this->pluginName);
                        
                    }else if($httpCode == 409){
                        
                        $message['error'] = __("The request conflicts with another request (perhaps due to using the same idempotent key).", $this->pluginName);
                        
                    }else if($httpCode == 429){
                        
                        $message['error'] = __("Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.", $this->pluginName);
                        
                    }else if($httpCode == 500 || $httpCode == 502 || $httpCode == 503 || $httpCode == 504){
                        
                        $message['error'] = __("Something went wrong on Stripe's end.", $this->pluginName);
                        
                    }else{
                        
                        $message['error'] = __("8007", $this->pluginName);
                        
                    }
                
                }
            
            }else{
                
                $message = $this->httpCodeError($httpCode, $payId);
                
            }
            
            return $message;
            
        }
        
        public function commitPayPal($payId, $secret, $token, $amont, $currency, $key, $name){
            
            $message = array();
            $bool = $this->payPalInclude();
            if($bool == true){
                
                $request = array('amount' => $amont, 'merchantAccountId' => $currency, 'paymentMethodNonce' => $token, 'orderId' => $key, 'options' => array('submitForSettlement' => true));
                $gateway = new Braintree_Gateway(array('accessToken' => $secret));
                $result = $gateway->transaction()->sale($request);
                if($result->success === true){
                    
                    $message['cardToken'] = $result->transaction->id;
                    $message['paymentId'] = $result->transaction->paypalDetails->paymentId;
                    $message['payerId'] = $result->transaction->paypalDetails->payerId;
                    
                }else{
                    
                    $message['error'] = $result->message;
                    
                }
                
                return $message;
                
            }else{
                
                return array('error' => "8020");
                
            }
            
        }
        
        public function getAccessTokenPayPal($public_key, $secret, $payment_live){
            
            $sandbox = '';
            if(intval($payment_live) == 0){
                
                $sandbox = 'sandbox.';
                
            }
            
            $url = "https://api.".$sandbox."paypal.com/v1/oauth2/token";
            $message = array();
            $headers = array('Accept: application/json', 'Accept-Language: en_US');
            $params = array('grant_type' => 'client_credentials');
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_USERPWD, $public_key.":".$secret);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
			curl_setopt($ch, CURLOPT_POST, 1);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close ($ch);
            $response = json_decode($response, true);
            return $response['access_token'];
            
        }
        
        public function getPaymentDetailsPayPal($id, $token, $payment_live){
            
            $sandbox = '';
            if(intval($payment_live) == 0){
                
                $sandbox = 'sandbox.';
                
            }
            
            $url = "https://api.".$sandbox."paypal.com/v1/payments/payment/".$id;
            $message = array();
            $headers = array('content-type: application/x-www-form-urlencoded', 'Accept: application/json', 'Authorization: Bearer '.$token);
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_POST, 0);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close ($ch);
            $response = json_decode($response, true);
            
            if(isset($response['transactions'][0]['related_resources'][0]['sale'])){
                
                $authorization = $response['transactions'][0]['related_resources'][0]['sale'];
                $message['cardToken'] = $authorization['id'];
                
            }else{
                
                #$message['status'] = 'error';
                
            }
            
            return $message;
            
        }
        
        public function updatePaymentPayPal($id, $bookingId, $token, $payment_live){
            
            $sandbox = '';
            if(intval($payment_live) == 0){
                
                $sandbox = 'sandbox.';
                
            }
            
            $url = "https://api.".$sandbox."paypal.com/v1/payments/payment/".$id;
            $message = array();
            $headers = array('Content-Type: application/json', 'Authorization: Bearer '.$token);
            $params = array(array('op' => 'replace', 'path' => '/transactions/0/custom', 'value' => 'Booking ID ' . $bookingId));
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
			#curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
			#curl_setopt($ch, CURLOPT_POST, 0);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
			$message['httpCode'] = $httpCode;
			$message['id'] = $id;
			$message['params'] = $params;
			
			return $message;
            
        }
        
        public function refoundPayPal($id, $token, $payment_live){
            
            $sandbox = '';
            if(intval($payment_live) == 0){
                
                $sandbox = 'sandbox.';
                
            }
            
            $url = "https://api.".$sandbox."paypal.com/v1/payments/sale/".$id;
            $message = array();
            $headers = array('content-type: application/json', 'Accept: application/json', 'Authorization: Bearer '.$token);
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_POST, 0);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
			
			if($httpCode == 200){
			    
			    $response = json_decode($response, true);
                $url = "https://api.".$sandbox."paypal.com/v1/payments/sale/".$id."/refund";
                $headers = array('content-type: application/json', 'Accept: application/json', 'Authorization: Bearer '.$token);
                $params = array('amount' => array('currency' => $response['amount']['currency'], 'total' => $response['amount']['total']));
                $response = null;
                
                $ch = curl_init();
    			curl_setopt($ch, CURLOPT_URL, $url);
    			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    			curl_setopt($ch, CURLOPT_POST, 1);
    			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
    			#curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
    			
                ob_start();
                $response = curl_exec($ch);
                $response = ob_get_contents();
                ob_end_clean();
                $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                curl_close($ch);
                $response = json_decode($response, true);
                $message['response'] = $response;
                if($httpCode != 201){
                    
                    $message['status'] = 'error';
                    $message['message'] = 'Refund failed';
                    
                }
                
			}
			
			
            return $message;
            
        }
        
        public function cancelStripe($payId, $secret, $chargeId){
            
            $url = "https://api.stripe.com/v1/refunds";
            $message = array();
            $params = array('charge' => $chargeId);
            $response = null;
            
            $ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_USERPWD, $secret.":");
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
			curl_setopt($ch, CURLOPT_POST, 1);
			
			ob_start();
			$response = curl_exec($ch);
			$response = ob_get_contents();
			ob_end_clean();
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close ($ch);
            
            $response = json_decode($response, true);
            if($httpCode < 400){
                
                if(isset($response['id']) && $response['status'] == 'succeeded'){
                    
                    $message['cardToken'] = $response['id'];
                    
                }
                	
            }else{
                
                $message = $this->httpCodeError($httpCode, $payId);
                
            }
            
            return $message;
            
        }
        
        public function cancelPayPal($payId, $secret, $chargeId){
            
            $message = array();
            $bool = $this->payPalInclude();
            if($bool == true){
                
                $gateway = new Braintree_Gateway(array('accessToken' => $secret));
                $result = $gateway->transaction()->refund($chargeId);
                if($result->success === true){
                    
                    $message['cardToken'] = $result->transaction->id;
                    
                }else{
                    
                    $message['error'] = $result->message;
                    
                }
                
                return $message;
                
            }else{
                
                return array('error' => "8020");
                
            }
            
        }
        
        public function httpCodeError($httpCode, $payId){
            
            $message = array();
            if($httpCode == 400){
                $message['error'] = __("The request was unacceptable, often due to missing a required parameter.", $this->pluginName);
            }else if($httpCode == 401){
                $message['error'] = __("No valid API key provided.", $this->pluginName);
            }else if($httpCode == 402){
                $message['error'] = __("The parameters were valid but the request failed.", $this->pluginName);
            }else if($httpCode == 404){
                $message['error'] = __("The requested resource doesn't exist.", $this->pluginName);
            }else if($httpCode == 409){
                $message['error'] = __("The request conflicts with another request (perhaps due to using the same idempotent key).", $this->pluginName);
            }else if($httpCode == 429){
                $message['error'] = __("Too many requests hit the API too quickly. We recommend an exponential backoff of your requests.", $this->pluginName);
            }else{
                $message['error'] = __("Something went wrong on Stripe's end.", $this->pluginName);
            }
            
            return $message;
            
        }
        
    }

?>